diff -r f40675df5d4c trytond/modules/account/tax.py
--- a/trytond/modules/account/tax.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/tax.py	Mon Sep 24 20:36:38 2012 +0200
@@ -1123,90 +1001,75 @@
         order_field='(%(table)s.sequence IS NULL) %(order)s, '
         '%(table)s.sequence %(order)s')
 
-    def __init__(self):
-        super(RuleLineTemplate, self).__init__()
-        self._order.insert(0, ('rule', 'ASC'))
-        self._order.insert(0, ('sequence', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(TaxRuleLineTemplate, cls).__setup__()
+        cls._order.insert(0, ('rule', 'ASC'))
+        cls._order.insert(0, ('sequence', 'ASC'))
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
-        super(RuleLineTemplate, self).init(module_name)
+        super(TaxRuleLineTemplate, cls).__register__(module_name)
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def _get_tax_rule_line_value(self, template, rule_line=None):
+    def _get_tax_rule_line_value(self, rule_line=None):
         '''
         Set values for tax rule line creation.
-
-        :param template: the BrowseRecord of the template
-        :param rule_line: the BrowseRecord of the rule line to update
-        :return: a dictionary with rule line fields as key and values as value
         '''
         res = {}
-        if not rule_line or rule_line.group.id != template.group.id:
-            res['group'] = template.group.id
-        if not rule_line or rule_line.origin_tax.id != template.origin_tax.id:
-            res['origin_tax'] = template.origin_tax.id
-        if not rule_line or rule_line.sequence != template.sequence:
-            res['sequence'] = template.sequence
-        if not rule_line or rule_line.template.id != template.id:
-            res['template'] = template.id
+        if not rule_line or rule_line.group.id != self.group.id:
+            res['group'] = self.group.id
+        if not rule_line or rule_line.origin_tax.id != self.origin_tax.id:
+            res['origin_tax'] = self.origin_tax.id
+        if not rule_line or rule_line.sequence != self.sequence:
+            res['sequence'] = self.sequence
+        if not rule_line or rule_line.template.id != self.id:
+            res['template'] = self.id
         return res
 
-    def create_rule_line(self, template, template2tax, template2rule,
+    def create_rule_line(self, template2tax, template2rule,
             template2rule_line=None):
         '''
         Create tax rule line based on template.
-
-        :param template: the template id or the BrowseRecord of template
-                used for tax rule line creation
-        :param template2tax: a dictionary with tax template id as key
-                and tax id as value, used to convert template id into
-                tax.
-        :param template2rule: a dictionary with tax rule template id as key
-                and tax rule id as value, used to convert template id into
-                tax rule.
-        :param template2rule_line: a dictionary with tax rule line template id
-                as key and tax rule line id as value, used to convert template
-                id into tax rule line. The dictionary is filled with new
-                tax rule lines
-        :return: id of the tax rule line created
+        template2tax is a dictionary with tax template id as key and tax id as
+        value, used to convert template id into tax.
+        template2rule is a dictionary with tax rule template id as key and tax
+        rule id as value, used to convert template id into tax rule.
+        template2rule_line is a dictionary with tax rule line template id as
+        key and tax rule line id as value, used to convert template id into tax
+        rule line. The dictionary is filled with new tax rule lines.
+        Return id of the tax rule line created
         '''
-        rule_line_obj = Pool().get('account.tax.rule.line')
+        RuleLine = Pool().get('account.tax.rule.line')
 
         if template2rule_line is None:
             template2rule_line = {}
 
-        if isinstance(template, (int, long)):
-            template = self.browse(template)
-
-        if template.id not in template2rule_line:
-            vals = self._get_tax_rule_line_value(template)
-            vals['rule'] = template2rule[template.rule.id]
-            if template.origin_tax:
-                vals['origin_tax'] = template2tax[template.origin_tax.id]
+        if self.id not in template2rule_line:
+            vals = self._get_tax_rule_line_value()
+            vals['rule'] = template2rule[self.rule.id]
+            if self.origin_tax:
+                vals['origin_tax'] = template2tax[self.origin_tax.id]
             else:
                 vals['origin_tax'] = None
-            if template.tax:
-                vals['tax'] = template2tax[template.tax.id]
+            if self.tax:
+                vals['tax'] = template2tax[self.tax.id]
             else:
                 vals['tax'] = None
-            new_id = rule_line_obj.create(vals)
-            template2rule_line[template.id] = new_id
-        else:
-            new_id = template2rule_line[template.id]
-        return new_id
+            new_rule_line = RuleLine.create(vals)
+            template2rule_line[self.id] = new_rule_line.id
+        return template2rule_line[self.id]
 
-RuleLineTemplate()
 
-
-class RuleLine(ModelSQL, ModelView):
+class TaxRuleLine(ModelSQL, ModelView):
     'Tax Rule Line'
-    _name = 'account.tax.rule.line'
-    _description = __doc__
+    __name__ = 'account.tax.rule.line'
+    _rec_name = 'tax'
     rule = fields.Many2One('account.tax.rule', 'Rule', required=True,
             select=True, ondelete='CASCADE')
     group = fields.Many2One('account.tax.group', 'Tax Group')
@@ -1229,132 +1092,111 @@
         '%(table)s.sequence %(order)s')
     template = fields.Many2One('account.tax.rule.line.template', 'Template')
 
-    def __init__(self):
-        super(RuleLine, self).__init__()
-        self._order.insert(0, ('rule', 'ASC'))
-        self._order.insert(0, ('sequence', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(TaxRuleLine, cls).__setup__()
+        cls._order.insert(0, ('rule', 'ASC'))
+        cls._order.insert(0, ('sequence', 'ASC'))
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
 
-        super(RuleLine, self).init(module_name)
+        super(TaxRuleLine, cls).__register__(module_name)
 
         # Migration from 2.4: drop required on sequence
         table.not_null_action('sequence', action='remove')
 
-    def match(self, line, pattern):
+    def match(self, pattern):
         '''
         Match line on pattern
+        pattern is a dictonary with rule line field as key and match value as
+        value.
+        '''
+        for field in pattern.keys():
+            if field not in self._fields:
+                continue
+            if not getattr(self, field) and field != 'group':
+                continue
+            if self._fields[field]._type == 'many2one':
+                if getattr(self, field).id != pattern[field]:
+                    return False
+            else:
+                if getattr(self, field) != pattern[field]:
+                    return False
+        return True
 
-        :param line: a BrowseRecord of rule line
-        :param pattern: a dictonary with rule line field as key
-                and match value as value
-        :return: a boolean
-        '''
-        res = True
-        for field in pattern.keys():
-            if field not in self._columns:
-                continue
-            if not line[field] and field != 'group':
-                continue
-            if self._columns[field]._type == 'many2one':
-                if line[field].id != pattern[field]:
-                    res = False
-                    break
-            else:
-                if line[field] != pattern[field]:
-                    res = False
-                    break
-        return res
-
-    def get_taxes(self, line):
+    def get_taxes(self):
         '''
         Return list of taxes for a line
-
-        :param line: a BrowseRecord of rule line
-        :return: a list of tax id
         '''
-        if line.tax:
-            return [line.tax.id]
+        if self.tax:
+            return [self.tax.id]
         return None
 
-    def update_rule_line(self, rule_line, template2tax, template2rule,
+    def update_rule_line(self, template2tax, template2rule,
             template2rule_line=None):
         '''
         Update tax rule line based on template.
-
-        :param rule_line: a rule line id or the BrowseRecord of the rule line
-        :param template2tax: a dictionary with tax template id as key
-                and tax id as value, used to convert template id into
-                tax.
-        :param template2rule: a dictionary with tax rule template id as key
-                and tax rule id as value, used to convert template id into
-                tax rule.
-        :param template2rule_line: a dictionary with tax rule line template id
-                as key and tax rule line id as value, used to convert template
-                id into tax rule line. The dictionary is filled with new
-                tax rule lines
+        template2tax is a dictionary with tax template id as key and tax id as
+        value, used to convert template id into tax.
+        template2rule is a dictionary with tax rule template id as key and tax
+        rule id as value, used to convert template id into tax rule.
+        template2rule_line is a dictionary with tax rule line template id as
+        key and tax rule line id as value, used to convert template id into tax
+        rule line. The dictionary is filled with new tax rule lines.
         '''
-        template_obj = Pool().get('account.tax.rule.line.template')
-
         if template2rule_line is None:
             template2rule_line = {}
 
-        if isinstance(rule_line, (int, long)):
-            rule_line = self.browse(rule_line)
+        if self.template:
+            vals = self.template._get_tax_rule_line_value(rule_line=self)
+            if self.rule.id != template2rule[self.template.rule.id]:
+                vals['rule'] = template2rule[self.template.rule.id]
+            if self.origin_tax:
+                if self.template.origin_tax:
+                    if self.origin_tax.id != \
+                            template2tax[self.template.origin_tax.id]:
+                        vals['origin_tax'] = template2tax[
+                            self.template.origin_tax.id]
+            if self.tax:
+                if self.template.tax:
+                    if self.tax.id != template2tax[self.template.tax.id]:
+                        vals['tax'] = template2tax[self.template.tax.id]
+            if vals:
+                self.write([self], vals)
+            template2rule_line[self.template.id] = self.id
 
-        if rule_line.template:
-            vals = template_obj._get_tax_rule_line_value(rule_line.template,
-                    rule_line=rule_line)
-            if rule_line.rule.id != template2rule[rule_line.template.rule.id]:
-                vals['rule'] = template2rule[rule_line.template.rule.id]
-            if rule_line.origin_tax:
-                if rule_line.template.origin_tax:
-                    if rule_line.origin_tax.id != \
-                            template2tax[rule_line.template.origin_tax.id]:
-                        vals['origin_tax'] = template2tax[
-                            rule_line.template.origin_tax.id]
-            if rule_line.tax:
-                if rule_line.template.tax:
-                    if rule_line.tax.id != \
-                            template2tax[rule_line.template.tax.id]:
-                        vals['tax'] = template2tax[rule_line.template.tax.id]
-            if vals:
-                self.write(rule_line.id, vals)
-            template2rule_line[rule_line.template.id] = rule_line.id
 
-RuleLine()
-
-
-class OpenCode(Wizard):
+class OpenTaxCode(Wizard):
     'Open Code'
-    _name = 'account.tax.open_code'
+    __name__ = 'account.tax.open_code'
     start_state = 'open_'
     open_ = StateAction('account.act_tax_line_form')
 
-    def do_open_(self, session, action):
+    def do_open_(self, action):
         pool = Pool()
-        fiscalyear_obj = pool.get('account.fiscalyear')
-        period_obj = pool.get('account.period')
+        FiscalYear = pool.get('account.fiscalyear')
+        Period = pool.get('account.period')
 
         if not Transaction().context.get('fiscalyear'):
-            fiscalyear_ids = fiscalyear_obj.search([
-                ('state', '=', 'open'),
-                ])
+            fiscalyears = FiscalYear.search([
+                    ('state', '=', 'open'),
+                    ])
         else:
-            fiscalyear_ids = [Transaction().context['fiscalyear']]
+            fiscalyears = [FiscalYear(Transaction().context['fiscalyear'])]
 
-        period_ids = []
+        periods = []
         if not Transaction().context.get('periods'):
-            period_ids = period_obj.search([
-                ('fiscalyear', 'in', fiscalyear_ids),
-                ])
+            periods = Period.search([
+                    ('fiscalyear', 'in', [f.id for f in fiscalyears]),
+                    ])
         else:
-            period_ids = Transaction().context['periods']
+            periods = Period.browse(Transaction().context['periods'])
 
         action['pyson_domain'] = PYSONEncoder().encode([
-                ('move_line.period', 'in', period_ids),
+                ('move_line.period', 'in', [p.id for p in periods]),
                 ('code', '=', Transaction().context['active_id']),
                 ])
         if Transaction().context.get('fiscalyear'):
@@ -1363,50 +1205,40 @@
                     })
         else:
             action['pyson_context'] = PYSONEncoder().encode({
-                    'periods': period_ids,
+                    'periods': [p.id for p in periods],
                     })
         return action, {}
 
-OpenCode()
-
 
 class AccountTemplateTaxTemplate(ModelSQL):
     'Account Template - Tax Template'
-    _name = 'account.account.template-account.tax.template'
+    __name__ = 'account.account.template-account.tax.template'
     _table = 'account_account_template_tax_rel'
-    _description = __doc__
     account = fields.Many2One('account.account.template', 'Account Template',
             ondelete='CASCADE', select=True, required=True)
     tax = fields.Many2One('account.tax.template', 'Tax Template',
             ondelete='RESTRICT', select=True, required=True)
 
-AccountTemplateTaxTemplate()
 
-
-class AccountTemplate(ModelSQL, ModelView):
-    _name = 'account.account.template'
+class AccountTemplate2:
+    __name__ = 'account.account.template'
     taxes = fields.Many2Many('account.account.template-account.tax.template',
             'account', 'tax', 'Default Taxes',
             domain=[('parent', '=', None)])
 
-AccountTemplate()
-
 
 class AccountTax(ModelSQL):
     'Account - Tax'
-    _name = 'account.account-account.tax'
+    __name__ = 'account.account-account.tax'
     _table = 'account_account_tax_rel'
-    _description = __doc__
     account = fields.Many2One('account.account', 'Account', ondelete='CASCADE',
             select=True, required=True)
     tax = fields.Many2One('account.tax', 'Tax', ondelete='RESTRICT',
             select=True, required=True)
 
-AccountTax()
 
-
-class Account(ModelSQL, ModelView):
-    _name = 'account.account'
+class Account2:
+    __name__ = 'account.account'
     taxes = fields.Many2Many('account.account-account.tax',
             'account', 'tax', 'Default Taxes',
             domain=[
@@ -1416,5 +1248,3 @@
             help='Default tax for manual encoding of move lines \n' \
                     'for journal types: "expense" and "revenue"',
             depends=['company'])
-
-Account()
diff -r f40675df5d4c trytond/modules/account/tests/test_account.py
--- a/trytond/modules/account/tests/test_account.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/tests/test_account.py	Mon Sep 24 20:36:38 2012 +0200
@@ -15,7 +15,6 @@
 from trytond.tests.test_tryton import test_view, test_depends
 from trytond.tests.test_tryton import POOL, DB_NAME, USER, CONTEXT
 from trytond.transaction import Transaction
-from trytond.wizard import Session
 
 
 class AccountTestCase(unittest.TestCase):
@@ -50,38 +49,33 @@
         'Test creation of minimal chart of accounts'
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            account_template_id, = self.account_template.search([
-                ('parent', '=', False),
-                ])
-            company_id, = self.company.search([('name', '=', 'B2CK')])
-            self.user.write(USER, {
-                    'main_company': company_id,
-                    'company': company_id,
+            account_template, = self.account_template.search([
+                    ('parent', '=', None),
+                    ])
+            company, = self.company.search([('name', '=', 'B2CK')])
+            self.user.write([self.user(USER)], {
+                    'main_company': company.id,
+                    'company': company.id,
                     })
             CONTEXT.update(self.user.get_preferences(context_only=True))
 
             session_id, _, _ = self.account_create_chart.create()
-            session = Session(self.account_create_chart, session_id)
-            session.data['account'].update({
-                    'account_template': account_template_id,
-                    'company': company_id,
-                    })
-            self.account_create_chart.transition_create_account(session)
-            receivable_id, = self.account.search([
+            create_chart = self.account_create_chart(session_id)
+            create_chart.account.account_template = account_template
+            create_chart.account.company = company
+            create_chart.transition_create_account()
+            receivable, = self.account.search([
                     ('kind', '=', 'receivable'),
-                    ('company', '=', company_id),
+                    ('company', '=', company.id),
                     ])
-            payable_id, = self.account.search([
+            payable, = self.account.search([
                     ('kind', '=', 'payable'),
-                    ('company', '=', company_id),
+                    ('company', '=', company.id),
                     ])
-            session.data['properties'].update({
-                    'company': company_id,
-                    'account_receivable': receivable_id,
-                    'account_payable': payable_id,
-                    })
-            self.account_create_chart.transition_create_properties(
-                session)
+            create_chart.properties.company = company
+            create_chart.properties.account_receivable = receivable
+            create_chart.properties.account_payable = payable
+            create_chart.transition_create_properties()
             transaction.cursor.commit()
 
     def test0020fiscalyear(self):
@@ -91,21 +85,20 @@
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
             today = datetime.date.today()
-            company_id, = self.company.search([('name', '=', 'B2CK')])
-            sequence_id = self.sequence.create({
+            company, = self.company.search([('name', '=', 'B2CK')])
+            sequence = self.sequence.create({
                     'name': '%s' % today.year,
                     'code': 'account.move',
-                    'company': company_id,
+                    'company': company.id,
                     })
-            fiscalyear_id = self.fiscalyear.create({
+            fiscalyear = self.fiscalyear.create({
                     'name': '%s' % today.year,
                     'start_date': today.replace(month=1, day=1),
                     'end_date': today.replace(month=12, day=31),
-                    'company': company_id,
-                    'post_move_sequence': sequence_id,
+                    'company': company.id,
+                    'post_move_sequence': sequence.id,
                     })
-            self.fiscalyear.create_period([fiscalyear_id])
-            fiscalyear = self.fiscalyear.browse(fiscalyear_id)
+            self.fiscalyear.create_period([fiscalyear])
             self.assertEqual(len(fiscalyear.periods), 12)
             transaction.cursor.commit()
 
diff -r e32ff462bf6e trytond/modules/account_invoice/__init__.py
--- a/trytond/modules/account_invoice/__init__.py	Mon Sep 10 15:27:42 2012 +0200
+++ b/trytond/modules/account_invoice/__init__.py	Mon Sep 24 20:36:39 2012 +0200
@@ -1,7 +1,37 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .payment_term import *
 from .invoice import *
 from .party import *
 from .account import *
+
+
+def register():
+    Pool.register(
+        PaymentTerm,
+        PaymentTermLine,
+        Invoice,
+        InvoicePaymentLine,
+        InvoiceLine,
+        InvoiceLineTax,
+        InvoiceTax,
+        PrintInvoiceWarning,
+        PayInvoiceStart,
+        PayInvoiceAsk,
+        CreditInvoiceStart,
+        Address,
+        Party,
+        FiscalYear,
+        Period,
+        Reconciliation,
+        module='account_invoice', type_='model')
+    Pool.register(
+        PrintInvoice,
+        PayInvoice,
+        CreditInvoice,
+        module='account_invoice', type_='wizard')
+    Pool.register(
+        InvoiceReport,
+        module='account_invoice', type_='report')
